require "import"
import "android.widget.TextView"
import "android.widget.Button"
import "android.widget.GridView"
import "android.widget.LinearLayout"
import "android.content.Context"
import "android.content.Intent"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"
import "java.util.Locale"
import "android.preference.PreferenceManager"
import "android.net.Uri"

local telegramLink = "https://t.me/jieshuofiles"

function kill()
  if speechRecognizer then
    speechRecognizer.destroy()
    speechRecognizer = nil
  end
end

function l()
  local languageCodes = {
    ["English"] = "en",
    ["Kannada"] = "kn-IN",
    ["Tamil"] = "ta-IN",
    ["Malayalam"] = "ml-IN",
    ["Telugu"] = "te-IN",
  ["Afrikaans"] = "af",
  ["Albanian"] = "sq",
  ["Amharic"] = "am",
  ["Arabic"] = "ar",
  ["Armenian"] = "hy",
  ["Azerbaijani"] = "az",
  ["Basque"] = "eu",
  ["Belarusian"] = "be",
  ["Bengali"] = "bn-IN",
  ["Bosnian"] = "bs",
  ["Bulgarian"] = "bg",
  ["Catalan"] = "ca",
  ["Cebuano"] = "ceb",
  ["Chinese (Simplified)"] = "zh-CN",
  ["Chinese (Traditional)"] = "zh-TW",
  ["Corsican"] = "co",
  ["Croatian"] = "hr",
  ["Czech"] = "cs",
  ["Danish"] = "da",
  ["Dutch"] = "nl",
   ["Esperanto"] = "eo",
  ["Estonian"] = "et",
  ["Finnish"] = "fi",
  ["French"] = "fr",
  ["Frisian"] = "fy",
  ["Galician"] = "gl",
  ["Georgian"] = "ka",
  ["German"] = "de",
  ["Greek"] = "el",
  ["Gujarati"] = "gu-IN",
  ["Haitian Creole"] = "ht",
  ["Hausa"] = "ha",
  ["Hawaiian"] = "haw",
  ["Hebrew"] = "he",
  ["Hindi"] = "hi-IN",
  ["Hmong"] = "hmn",
  ["Hungarian"] = "hu",
  ["Icelandic"] = "is",
  ["Igbo"] = "ig",
  ["Indonesian"] = "id",
  ["Irish"] = "ga",
  ["Italian"] = "it",
  ["Japanese"] = "ja",
  ["Javanese"] = "jv",
   ["Kazakh"] = "kk",
  ["Khmer"] = "km",
  ["Kinyarwanda"] = "rw",
  ["Korean"] = "ko",
  ["Kurdish"] = "ku",
  ["Kyrgyz"] = "ky",
  ["Lao"] = "lo",
  ["Latin"] = "la",
  ["Latvian"] = "lv",
  ["Lithuanian"] = "lt",
  ["Luxembourgish"] = "lb",
  ["Macedonian"] = "mk",
  ["Malagasy"] = "mg",
  ["Malay"] = "ms",
    ["Maltese"] = "mt",
  ["Maori"] = "mi",
  ["Marathi"] = "mr-IN",
  ["Mongolian"] = "mn",
  ["Myanmar (Burmese)"] = "my",
  ["Nepali"] = "ne-IN",
  ["Norwegian"] = "no",
  ["Nyanja (Chichewa)"] = "ny",
  ["Odia (Oriya)"] = "or",
  ["Pashto"] = "ps",
  ["Persian"] = "fa",
  ["Polish"] = "pl",
  ["Portuguese"] = "pt",
  ["Punjabi"] = "pa-IN",
  ["Romanian"] = "ro",
  ["Russian"] = "ru",
  ["Samoan"] = "sm",
  ["Scots Gaelic"] = "gd",
  ["Serbian"] = "sr",
  ["Sesotho"] = "st",
  ["Shona"] = "sn",
  ["Sindhi"] = "sd",
  ["Sinhala (Sinhalese)"] = "si",
  ["Slovak"] = "sk",
  ["Slovenian"] = "sl",
  ["Somali"] = "so",
  ["Spanish"] = "es",
  ["Sundanese"] = "su",
  ["Swahili"] = "sw",
  ["Swedish"] = "sv",
  ["Tagalog (Filipino)"] = "tl",
  ["Tajik"] = "tg",
    ["Tatar"] = "tt",
    ["Thai"] = "th",
  ["Turkish"] = "tr",
  ["Turkmen"] = "tk",
  ["Ukrainian"] = "uk",
  ["Urdu"] = "ur",
  ["Uyghur"] = "ug",
  ["Uzbek"] = "uz",
  ["Vietnamese"] = "vi",
  ["Welsh"] = "cy",
  ["Xhosa"] = "xh",
  ["Yiddish"] = "yi",
  ["Yoruba"] = "yo",
  ["Zulu"] = "zu"
 }

  local items = {}
  local preferredLanguages = {"English", "Kannada", "Tamil", "Telugu", "Malayalam"}

  -- Add preferred languages first
  for _, lang in ipairs(preferredLanguages) do
    items[#items + 1] = lang
  end

  -- Add remaining languages alphabetically
  local remainingLanguages = {}
  for lang, _ in pairs(languageCodes) do
    if not table.find(preferredLanguages, lang) then
      table.insert(remainingLanguages, lang)
    end
  end
  table.sort(remainingLanguages, function(a, b) return a < b end)

  for _, lang in ipairs(remainingLanguages) do
    items[#items + 1] = lang
  end

  local layout = {
    LinearLayout,  -- This specifies the root layout type
    orientation = "vertical",
    layout_width = "fill",
    layout_height = "fill",
    {
      TextView,
      text = "Voice Dictation, v2.0",
      id = "voiceDictationmsg",
      layout_width = "wrap_content",
      layout_height = "wrap_content",
      layout_gravity = "center",
      textSize = "18sp"
    },
    {
      Button,
      text = "join Telegram",
      id = "telegramButton",
      layout_width = "wrap_content",
      layout_height = "wrap_content",
      layout_gravity = "center"
    },
    {
      GridView,
      id = "grid",
      numColumns = 1,
      layout_width = "fill",
      layout_height = "wrap_content"
    }
  }

  local dlg = LuaDialog(this)
  dlg.View = loadlayout(layout)
  grid.adapter = SingleLineAdapter(service, items)

  local sharedPrefs = PreferenceManager.getDefaultSharedPreferences(this)
  local storedLanguage = sharedPrefs.getString("selectedLanguage", nil)
  local selectedLanguage = nil

  if storedLanguage and languageCodes[storedLanguage] then
    selectedLanguage = storedLanguage
  else
    dlg.setTitle("Select Language")
  end

  dlg.setButton("Exit", nil)
  dlg.show()

  grid.onItemClick = function(l, v)
    dlg.dismiss()
    task(500, function()
      local language = v.text
      languageCode = languageCodes[language]

      if languageCode then
        selectedLanguage = language
        local editor = sharedPrefs.edit()
        editor.putString("selectedLanguage", selectedLanguage)
        editor.apply()
        service.speak(language .. " language has been selected")
      end
    end)
  end

  telegramButton.onClick = function()
    local intent = Intent(Intent.ACTION_VIEW)
    intent.setData(Uri.parse(telegramLink))
    this.startActivity(intent)
    dlg.dismiss()
  end

  voiceDictationmsg.requestFocus()
end

function table.find(tbl, val)
  for _, v in ipairs(tbl) do
    if v == val then
      return true
    end
  end
  return false
end

if speechRecognizer then
  kill()
  l()
else
  function hasInternetConnection()
    local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)
    local networkInfo = connectivityManager.getActiveNetworkInfo()
    return networkInfo ~= nil and networkInfo.isConnected()
  end

  function kill()
    if speechRecognizer then
      speechRecognizer.destroy()
      speechRecognizer = nil
    end
  end

  function startListening()
    if not hasInternetConnection() then
      service.asyncSpeak("இணைய இணைப்பு இல்லை.இணைய இணைப்பை சரி பார்த்த பிறகு  மீண்டும் முயலவும்.")
      return false
    end

    local verbalizationDetected = false

    speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)

    speechListener = RecognitionListener{
      onResults = function(results)
        local data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        if data ~= nil and data.size() > 0 then
          verbalizationDetected = true
          local recognizedText = data.get(0)
          local node = service.getEditText()
          local editText = service.getText(node)

          if editText and string.len(editText) > 0 then
            recognizedText = recognizedText
          end

          service.insertText(node, recognizedText .. ". ")
          service.speak(recognizedText)
          kill()

          -- Speech recognition success: wait 2 seconds and restart
          task(2000, stopListening)
        end

        if not verbalizationDetected then
          kill()
          return false
        end
      end,
      onError = function()
        kill()
        return false
      end
    }

    recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, languageCode)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())

    speechRecognizer.startListening(recognizerIntent)
    speechRecognizer.setRecognitionListener(speechListener)

    return true
  end

  startListening()
  return true
end